'
'************************************************
'Draws all sprites and controls how they behave
'************************************************
SUB DrawSprites
    _DEST CollisionData&
    CLS
    _DEST SpriteScreen&
    CLS
    _CLEARCOLOR _RGB(0, 0, 0)

    IF Player1.Health >= 1 THEN
        IF Player1.NoDraw = 0 THEN
            IF Settings.Menu = 0 THEN
                IF Player1.PosX - 2 < 1 AND Player1.Stageover = 0 THEN Player1.PosX = 3
                IF Player1.PosX + 63 > Settings.RezX - 1 AND Player1.Stageover = 0 THEN Player1.PosX = Settings.RezX - 64
                IF Player1.PosY - 2 < 1 AND Player1.Stageover = 0 THEN Player1.PosY = 3
                IF Player1.PosY + 18 > Settings.RezY - 1 AND Player1.Stageover = 0 THEN Player1.PosY = Settings.RezY - 19
            END IF

            _DEST CollisionData&
            LINE (Player1.PosX - 2, Player1.PosY - 2)-(Player1.PosX + 62, Player1.PosY + 17), _RGB(255, 0, 254), BF
            _DEST SpriteScreen&
            _PUTIMAGE (Player1.PosX, Player1.PosY), ShipSprites(Player1.Frame), SpriteScreen&
        END IF
    ELSEIF Player1.Health < 1 AND Player1.Dead = 0 THEN
        CALL SetupSprite(Player1.PosX, Player1.PosY, 0, 0, "Expl3", 10, 1, 3, 3, 2, 0, 1, 0)
        Settings.DisableSpawning = 1
        Player1.Health = -1
        Player1.Dead = 1
        Player1.Locked = 1
        DeadPlayerTimers
    END IF

    FOR x = 21 TO TotalSprites
        IF Sprites(x).Active = 1 THEN

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "SLasp" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).Counter >= Sprites(x).Delay THEN
                    Sprites(x).Frame = Sprites(x).Frame + 1
                    IF Sprites(x).Frame = 5 THEN Sprites(x).Frame = 1
                    Sprites(x).Counter = 0
                ELSE
                    Sprites(x).Counter = Sprites(x).Counter + 1
                END IF

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), SlaserSprites(Sprites(x).Frame), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Speed" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).Counter >= Sprites(x).Delay THEN
                    Sprites(x).Frame = Sprites(x).Frame + 1
                    IF Sprites(x).Frame = 5 THEN Sprites(x).Frame = 1
                    Sprites(x).Counter = 0
                ELSE
                    Sprites(x).Counter = Sprites(x).Counter + 1
                END IF

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), SpeedSprites(Sprites(x).Frame), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Heal5" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).Counter >= Sprites(x).Delay THEN
                    Sprites(x).Frame = Sprites(x).Frame + 1
                    IF Sprites(x).Frame = 5 THEN Sprites(x).Frame = 1
                    Sprites(x).Counter = 0
                ELSE
                    Sprites(x).Counter = Sprites(x).Counter + 1
                END IF

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Health5Sprites(Sprites(x).Frame), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Heal1" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).Counter >= Sprites(x).Delay THEN
                    Sprites(x).Frame = Sprites(x).Frame + 1
                    IF Sprites(x).Frame = 5 THEN Sprites(x).Frame = 1
                    Sprites(x).Counter = 0
                ELSE
                    Sprites(x).Counter = Sprites(x).Counter + 1
                END IF

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Health1Sprites(Sprites(x).Frame), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship8" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY

                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN
                    Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY - Sprites(x).Size, -25, Yoffset, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)
                    Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY + Sprites(x).Size, -25, Yoffset, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)
                END IF

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0
                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(8), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship7" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).MovementSwitch = 1 THEN
                    Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY
                    IF Sprites(x).PosY < 5 + Sprites(x).Size THEN Sprites(x).MovementSwitch = 2
                ELSEIF Sprites(x).MovementSwitch = 2 THEN
                    Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                    IF Sprites(x).PosY > Settings.RezY - Sprites(x).Size THEN Sprites(x).MovementSwitch = 1
                END IF

                SwitchMovement = INT(RND * 25) + 1
                IF SwitchMovement = 5 THEN
                    IF Sprites(x).MovementSwitch = 1 THEN Sprites(x).MovementSwitch = 2
                    IF Sprites(x).MovementSwitch = 2 THEN Sprites(x).MovementSwitch = 1
                END IF

                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY - Sprites(x).Size, -25, 0, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)

                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY + Sprites(x).Size, -25, 0, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0
                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(7), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship6" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).Frame = 1 THEN
                    Teleport = INT(RND * 25) + 1
                    IF Teleport = 5 THEN
                        _SNDPLAY SFX(11)
                        Sprites(x).Frame = 2
                        Sprites(x).AnimationLoops = 1
                    END IF

                    Fire = INT(RND * 6) + 1
                    IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY - Sprites(x).Size, -15, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)

                    Fire = INT(RND * 10) + 1
                    IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY + Sprites(x).Size, -15, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)

                    IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0
                    IF Sprites(x).Health < 1 THEN
                        Sprites(x).Active = 0
                        PowerUpDrop (x)
                        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                    END IF
                END IF

                IF Sprites(x).Active = 1 AND Sprites(x).Frame = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(6), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                ELSEIF Sprites(x).Active = 1 AND Sprites(x).Frame = 2 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), TeleportSprites(Sprites(x).AnimationLoops), SpriteScreen&
                    Sprites(x).AnimationLoops = Sprites(x).AnimationLoops + 1
                    IF Sprites(x).AnimationLoops = 11 THEN Sprites(x).Frame = 3
                ELSEIF Sprites(x).Active = 1 AND Sprites(x).Frame = 3 THEN
                    Sprites(x).AnimationLoops = 10
                    Sprites(x).PosY = Player1.PosY 'INT(RND * (Settings.RezY - 10)) + 5
                    Sprites(x).Frame = 4
                    _SNDPLAY SFX(11)
                ELSEIF Sprites(x).Active = 1 AND Sprites(x).Frame = 4 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), TeleportSprites(Sprites(x).AnimationLoops), SpriteScreen&
                    Sprites(x).AnimationLoops = Sprites(x).AnimationLoops - 1
                    IF Sprites(x).AnimationLoops = 0 THEN Sprites(x).Frame = 1
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship5" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY

                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY - Sprites(x).Size, -15, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)

                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY + Sprites(x).Size, -15, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0
                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(5), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship4" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX

                IF Sprites(x).MovementSwitch = 1 THEN
                    Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY
                    IF Sprites(x).PosY < 5 + Sprites(x).Size THEN Sprites(x).MovementSwitch = 2
                ELSEIF Sprites(x).MovementSwitch = 2 THEN
                    Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                    IF Sprites(x).PosY > Settings.RezY - Sprites(x).Size THEN Sprites(x).MovementSwitch = 1
                END IF

                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN
                    Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY - Sprites(x).Size, -12, Yoffset, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                END IF
                Fire = INT(RND * 10) + 1
                IF Fire = 3 THEN
                    Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY + Sprites(x).Size, -12, Yoffset, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                END IF

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0
                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(4), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF


            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship3" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY

                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(3), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship2" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                Fire = INT(RND * 20) + 1
                IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -20, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(2), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ship1" AND Sprites(x).Active = 1 THEN
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 20, 1, 0, 2, 0, 0, 1, 0)
                END IF

                Fire = INT(RND * 20) + 1
                IF Fire = 3 THEN
                    Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -7, Yoffset, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), EnemySprites(1), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Lase4" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(12)
                    Sprites(x).Frame = 1
                END IF

                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0

                _SOURCE CollisionData&
                Collision = _BLUE(POINT(Sprites(x).PosX - (Sprites(x).Size + 1), Sprites(x).PosY))
                IF Collision = 254 THEN
                    Player1.Health = Player1.Health - 2
                    IF Player1.Health < 0 THEN Player1.Health = 0
                    Sprites(x).Active = 0
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 15, 0, 2, 2, 0, 0, 1, 0)
                END IF
                _SOURCE Display&

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser4Sprite, SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Ball1" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(4)
                    Sprites(x).Frame = 1
                END IF

                Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                IF Sprites(x).PosX <= 0 THEN Sprites(x).Active = 0
                IF Sprites(x).PosY <= 0 OR Sprites(x).PosY >= Settings.RezY THEN Sprites(x).Active = 0

                Sprites(x).Frame = Sprites(x).Frame + 1
                IF Sprites(x).Frame = 5 THEN Sprites(x).Frame = 1
                _SOURCE CollisionData&
                Collision = _BLUE(POINT(Sprites(x).PosX - (Sprites(x).Size + 1), Sprites(x).PosY))
                IF Collision = 254 THEN
                    Player1.Health = Player1.Health - 1
                    Sprites(x).Active = 0
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 15, 0, 2, 2, 0, 0, 1, 0)
                END IF
                _SOURCE Display&

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Ball1Sprites(Sprites(x).Frame), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Boss1" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    CALL JukeBox2("Boss","Swap")
                    Sprites(x).Frame = 1
                    Sprites(x).MovementSwitch = 1
                END IF

                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    CALL SetupSprite(Sprites(98).PosX + 50, Sprites(98).PosY + 50, 0, 0, "Expl2", 20, 20, 0, 2, 1, 99, 2, 0)
                    CALL JukeBox2("Level","Swap")
                END IF

                IF Sprites(x).MovementSwitch = 1 THEN
                    Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY
                    IF Sprites(x).PosY < 5 + Sprites(x).Size THEN Sprites(x).MovementSwitch = 2
                ELSEIF Sprites(x).MovementSwitch = 2 THEN
                    Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                    IF Sprites(x).PosY > Settings.RezY - Sprites(x).Size THEN Sprites(x).MovementSwitch = 1
                END IF

                Fire = INT(RND * 8) + 1

                IF Fire = 3 THEN
                    Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                    CALL SetupSprite(Sprites(98).PosX, Sprites(98).PosY, -7, Yoffset, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss1Sprite, SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Boss2" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    CALL JukeBox2("Boss","Swap")
                    Sprites(x).Frame = 1
                    Sprites(x).MovementSwitch = 1
                    CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, 0, 0, "Bos2a", Sprites(x).Size, 0, 0, 1, 0, 97, 0, INT(Sprites(x).Health / 2))
                    CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, 0, 0, "Bos2b", Sprites(x).Size, 0, 0, 1, 0, 98, 0, INT(Sprites(x).Health / 2))
                END IF

                IF Sprites(x).Frame = 1 THEN
                    IF Sprites(x).MovementSwitch = 1 THEN
                        Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY
                        IF Sprites(x).PosY < 5 + Sprites(x).Size THEN Sprites(x).MovementSwitch = 2
                    ELSEIF Sprites(x).MovementSwitch = 2 THEN
                        Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                        IF Sprites(x).PosY > Settings.RezY - Sprites(x).Size THEN Sprites(x).MovementSwitch = 1
                    END IF

                    IF Sprites(97).Active = 0 AND Sprites(98).Active = 0 THEN Sprites(x).Frame = 2: CALL SetupSprite(Sprites(96).PosX - Sprites(96).Size, Sprites(96).PosY, 0, 0, "Lase3", 20, 0, 0, 2, 1, 94, 2, 0)
                    IF Sprites(x).Active = 1 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss2Sprites(1), SpriteScreen&

                ELSEIF Sprites(x).Frame = 2 THEN
                    IF Sprites(x).Health < 1 THEN
                        Sprites(x).Active = 0
                        CALL JukeBox2("Level","Swap")
                        CALL SetupSprite(Sprites(96).PosX + 50, Sprites(96).PosY + 50, 0, 0, "Expl2", 20, 20, 0, 2, 1, 99, 2, 0)
                    END IF

                    IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + 7
                    IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - 7
                    IF Sprites(94).Active = 0 THEN Fire = INT(RND * 30) + 1

                    IF Fire = 8 THEN
                        CALL SetupSprite(Sprites(96).PosX - Sprites(96).Size, Sprites(96).PosY, 0, 0, "Lase3", 20, 0, 0, 2, 1, 94, 2, 0)
                    END IF

                    IF Sprites(x).Active = 1 THEN
                        _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss2Sprites(1), SpriteScreen&
                        _DEST CollisionData&
                        LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - INT(Sprites(x).Size / 2))-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + INT(Sprites(x).Size / 2)), _RGB(0, 0, 96), BF
                        _DEST SpriteScreen&
                    END IF
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------
            IF Sprites(x).SpriteName = "Lase3" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(9)
                    Sprites(x).Frame = 1
                END IF

                IF Sprites(x).Active = 1 THEN
                    IF Sprites(x).Frame < 8 THEN
                        _PUTIMAGE (Sprites(96).PosX, Sprites(96).PosY - Sprites(x).Size)-(0, Sprites(96).PosY + Sprites(x).Size), Laser3Sprite(Sprites(x).Frame), SpriteScreen&
                        IF Sprites(x).Counter >= Sprites(x).Delay THEN
                            Sprites(x).Frame = Sprites(x).Frame + 1
                            Sprites(x).Counter = 0
                        ELSE
                            Sprites(x).Counter = Sprites(x).Counter + 1
                        END IF
                    ELSEIF Sprites(x).Frame > 7 AND Sprites(x).Frame < 15 THEN
                        IF Player1.PosY > Sprites(96).PosY - Sprites(x).Size AND Player1.PosY < Sprites(96).PosY + Sprites(x).Size AND Player1.Health > 0 THEN Player1.Health = 0
                        _PUTIMAGE (Sprites(96).PosX, Sprites(96).PosY - Sprites(x).Size)-(0, Sprites(96).PosY + Sprites(x).Size), Laser3Sprite(7), SpriteScreen&
                        _PUTIMAGE (Sprites(96).PosX, Sprites(96).PosY - 50)-(0, Sprites(96).PosY + 50), Lightning1Sprites(Sprites(x).Frame - 7), SpriteScreen&
                        Sprites(x).Frame = Sprites(x).Frame + 1
                    ELSEIF Sprites(x).Frame = 15 THEN
                        Sprites(x).Frame = 27
                        IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(10)
                    ELSEIF Sprites(x).Frame > 20 THEN
                        _PUTIMAGE (Sprites(96).PosX, Sprites(96).PosY - Sprites(x).Size)-(0, Sprites(96).PosY + Sprites(x).Size), Laser3Sprite(Sprites(x).Frame - 20), SpriteScreen&
                        Sprites(x).Frame = Sprites(x).Frame - 1
                    ELSEIF Sprites(x).Frame = 20 THEN
                        Sprites(x).Active = 0
                    END IF
                END IF
            END IF
            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Bos2a" OR Sprites(x).SpriteName = "Bos2b" THEN
                IF Sprites(x).Active = 1 THEN

                    IF Sprites(x).Health < 1 THEN
                        Sprites(x).Active = 0
                        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl3", 10, 1, 3, 3, 2, 0, 1, 0)
                    END IF

                    Sprites(x).PosX = Sprites(96).PosX
                    Sprites(x).PosY = Sprites(96).PosY
                    Fire = INT(RND * 8) + 1

                    IF Fire = 3 THEN
                        Yoffset = ((INT(RND * 40) + 1) / 10) - 2
                        IF Sprites(x).SpriteName = "Bos2a" THEN
                            CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY - INT(Sprites(x).Size / 2), -7, Yoffset, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                        ELSE
                            CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY + INT(Sprites(x).Size / 2), -7, Yoffset, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                        END IF
                    END IF
                END IF

                IF Sprites(x).Active = 1 THEN
                    IF Sprites(x).SpriteName = "Bos2a" THEN
                        _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss2Sprites(2), SpriteScreen&
                        _DEST CollisionData&
                        LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY), _RGB(255, 0, Sprites(x).ColColorB), BF
                        _DEST SpriteScreen&
                    ELSE
                        _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss2Sprites(3), SpriteScreen&
                        _DEST CollisionData&
                        LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(0, 255, Sprites(x).ColColorB), BF
                        _DEST SpriteScreen&
                    END IF
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------
            IF Sprites(x).SpriteName = "Boss3" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    CALL JukeBox2("Boss","Swap")
                    Sprites(x).Frame = 1
                    Sprites(x).AnimationLoops = Sprites(x).Health
                    CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, 0, 0, "Bos3t", Sprites(x).Size, 0, 0, 1, 0, 97, 0, INT(Sprites(x).Health / 2))
                    CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, 0, 0, "Bos3b", Sprites(x).Size, 0, 0, 1, 0, 98, 0, INT(Sprites(x).Health / 2))
                END IF

                IF Sprites(x).Frame = 1 THEN
                    IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + 7
                    IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - 7
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(1), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(4), SpriteScreen&
                    IF Sprites(97).Active = 0 AND Sprites(98).Active = 0 THEN Sprites(x).Frame = 2
                    Fire = INT(RND * 8) + 1

                    IF Fire = 3 THEN CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, -20, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)

                ELSEIF Sprites(x).Frame = 2 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(1), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(4), SpriteScreen&
                    Sprites(x).Counter = Sprites(x).Counter + 1
                    IF Sprites(x).Counter = 100 THEN Sprites(x).Frame = 3
                ELSEIF Sprites(x).Frame = 3 THEN
                    FOR y = 1 TO 10
                        CALL SetupSprite(Sprites(x).PosX + 20, (Sprites(x).PosY - 50) + (y * 10), 0, 0, "Expl1", 15, 0, 4, 2, 0, 0, 1, 0)
                    NEXT y
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(1), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(4), SpriteScreen&
                    CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, -2, 7, "Bos3f", Sprites(x).Size, 0, 0, 1, 0, 98, 0, INT(Sprites(x).Health / 2))
                    Sprites(x).Frame = 4
                ELSEIF Sprites(x).Frame = 4 THEN

                    IF Sprites(94).Active = 0 THEN Fire = INT(RND * 30) + 1
                    IF Fire = 8 THEN
                        CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY, 0, 0, "Lase3", 20, 0, 0, 2, 1, 94, 2, 0)
                    END IF
                    Fire = INT(RND * 10) + 1
                    IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -25, Yoffset, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)

                    IF Sprites(x).Health < 20 THEN Sprites(x).Health = Sprites(x).AnimationLoops
                    IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + 7
                    IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - 7

                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(1), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX, Sprites(x).PosY - 60)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + 60), _RGB(0, 255, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                    IF Sprites(98).Active = 0 THEN Sprites(x).Frame = 5: Sprites(x).Health = Sprites(x).AnimationLoops
                ELSEIF Sprites(x).Frame = 5 THEN

                    IF Sprites(x).Health < 1 THEN
                        Sprites(x).Active = 0
                        CALL JukeBox2("Boss","Stop")
                        CALL JukeBox2("Intro","Loop")
                        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl3", 10, 1, 3, 3, 2, 0, 1, 0)
                    END IF

                    IF Sprites(94).Active = 0 THEN Fire = INT(RND * 30) + 1
                    IF Fire = 8 THEN
                        CALL SetupSprite(Sprites(96).PosX - Sprites(96).Size, Sprites(96).PosY, 0, 0, "Lase3", 20, 0, 0, 2, 1, 94, 2, 0)
                    END IF
                    Fire = INT(RND * 10) + 1
                    IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -25, Yoffset, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)

                    IF Sprites(x).PosY < Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY + 7
                    IF Sprites(x).PosY > Player1.PosY THEN Sprites(x).PosY = Sprites(x).PosY - 7

                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(1), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX, Sprites(x).PosY - 60)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + 60), _RGB(0, 255, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Bos3f" THEN
                IF Sprites(x).Active = 1 THEN

                    IF Sprites(x).Health < 1 THEN
                        Sprites(x).Active = 0
                        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl3", 10, 1, 3, 3, 2, 0, 1, 0)
                    END IF

                    IF Sprites(x).Frame = 0 THEN
                        Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                        Sprites(x).Counter = Sprites(x).Counter + 1
                        IF Sprites(x).Counter = 50 THEN Sprites(x).Frame = 1
                    ELSEIF Sprites(x).Frame = 1 THEN
                        IF Sprites(x).MovementSwitch = 1 THEN
                            Sprites(x).PosY = Sprites(x).PosY - Sprites(x).MoveY
                            IF Sprites(x).PosY < 5 + Sprites(x).Size THEN Sprites(x).MovementSwitch = 2
                        ELSEIF Sprites(x).MovementSwitch = 2 THEN
                            Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                            IF Sprites(x).PosY > Settings.RezY - Sprites(x).Size THEN Sprites(x).MovementSwitch = 1
                        END IF

                        Fire = INT(RND * 10) + 1
                        IF Fire = 3 THEN CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -25, Yoffset, "Lase4", 5, 0, 0, 1, 1, 0, 1, 0)
                    END IF
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(4), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - 60, Sprites(x).PosY - 30)-(Sprites(x).PosX + 30, Sprites(x).PosY + 30), _RGB(255, 0, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF
            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Bos3t" OR Sprites(x).SpriteName = "Bos3b" THEN
                IF Sprites(x).Active = 1 THEN
                    'shoot ball
                    IF Sprites(x).Health < 1 THEN
                        Sprites(x).Active = 0
                        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl3", 10, 1, 3, 3, 2, 0, 1, 0)
                    END IF

                    Sprites(x).PosX = Sprites(96).PosX
                    Sprites(x).PosY = Sprites(96).PosY
                    Fire = INT(RND * 8) + 1

                    IF Fire = 3 THEN
                        IF Sprites(x).SpriteName = "Bos3t" THEN
                            CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY - INT(Sprites(x).Size / 2), -20, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                        ELSE
                            CALL SetupSprite(Sprites(96).PosX, Sprites(96).PosY + INT(Sprites(x).Size / 2), -20, 0, "Ball1", 5, 0, 0, 3, 99, 0, 1, 0)
                        END IF
                    END IF

                END IF

                IF Sprites(x).Active = 1 THEN
                    IF Sprites(x).SpriteName = "Bos3t" THEN
                        _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(2), SpriteScreen&
                        _DEST CollisionData&
                        LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY), _RGB(255, 0, Sprites(x).ColColorB), BF
                        _DEST SpriteScreen&
                    ELSE
                        _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Boss3Sprites(3), SpriteScreen&
                        _DEST CollisionData&
                        LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(0, 255, Sprites(x).ColColorB), BF
                        _DEST SpriteScreen&
                    END IF
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Aste1" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    Sprites(x).Frame = 1
                END IF

                IF Sprites(x).PosX < 0 THEN
                    Sprites(x).Active = 0
                ELSE
                    Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                    IF Sprites(x).Counter >= Sprites(x).Delay THEN
                        Sprites(x).Frame = Sprites(x).Frame + 1
                        IF Sprites(x).Frame = 4 THEN Sprites(x).Frame = 1
                        Sprites(x).Counter = 0
                    ELSE
                        Sprites(x).Counter = Sprites(x).Counter + 1
                    END IF
                END IF

                IF Sprites(x).Health < 1 THEN
                    Sprites(x).Active = 0
                    PowerUpDrop (x)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl1", 15, 1, 0, 2, 0, 0, 1, 0)
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), AsteroidSprite(Sprites(x).Frame), SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), _RGB(Sprites(x).ColColorR, Sprites(x).ColColorG, Sprites(x).ColColorB), BF
                    _DEST SpriteScreen&
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Expl1" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 AND Settings.DisableSound = 0 THEN
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(1)
                    IF Sprites(x).SoundDisabled = 2 THEN _SNDPLAY SFX(5)
                    IF Sprites(x).SoundDisabled = 3 THEN _SNDPLAY SFX(6)
                    IF Sprites(x).SoundDisabled = 4 THEN _SNDPLAY SFX(13)
                    Sprites(x).Frame = 1
                ELSE
                    IF Sprites(x).Counter = Sprites(x).Delay THEN
                        Sprites(x).Counter = 0
                        Sprites(x).Frame = Sprites(x).Frame + 1
                        Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                        Sprites(x).PosY = Sprites(x).PosY + Sprites(x).MoveY
                        Sprites(x).Size = Sprites(x).Size + Sprites(x).Growth
                        IF Sprites(x).Frame = 15 AND Sprites(x).AnimationType = 2 THEN
                            Sprites(x).Active = 0
                        ELSEIF Sprites(x).Frame = 15 AND Sprites(x).AnimationType = 3 THEN
                            IF Sprites(x).AnimationLooped <> Sprites(x).AnimationLoops THEN
                                Sprites(x).Frame = 1
                                Sprites(x).AnimationLooped = Sprites(x).AnimationLooped + 1
                            ELSE
                                Sprites(x).Active = 0
                            END IF
                        END IF
                    ELSE
                        Sprites(x).Counter = Sprites(x).Counter + 1
                    END IF
                END IF
                IF Sprites(x).Active = 1 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Explosion1Sprites(Sprites(x).Frame), SpriteScreen&
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Expl2" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(2)
                    CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 0, "Expl3", 10, 1, 1, 3, 2, 0, 1, 0)
                    Sprites(x).Frame = 1
                ELSE
                    IF Sprites(x).Counter = Sprites(x).Delay THEN
                        Sprites(x).Counter = 0
                        Sprites(x).Frame = Sprites(x).Frame + 1
                        Sprites(x).Size = Sprites(x).Size + Sprites(x).Growth
                        IF Sprites(x).Frame = 6 THEN
                            Sprites(x).Active = 0
                        END IF
                    ELSE
                        Sprites(x).Counter = Sprites(x).Counter + 1
                    END IF
                END IF
                IF Sprites(x).Active = 1 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Explosion2Sprites(Sprites(x).Frame), SpriteScreen&
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Expl3" AND Sprites(x).Active = 1 THEN
                Sprites(x).Active = 0
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 7, 0, "Expl1", Sprites(x).Size, Sprites(x).Growth, Sprites(x).SoundDisabled, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, 7, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -7, 0, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 0, -7, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -5, -5, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 5, -5, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -5, 5, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
                CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, 5, 5, "Expl1", Sprites(x).Size, Sprites(x).Growth, 1, Sprites(x).AnimationType, Sprites(x).AnimationLoops, 0, Sprites(x).Delay, 0)
            END IF

            '---------------------------------------------------------------------------------------------------------
        END IF
    NEXT x


    FOR x = 1 TO 20
        IF Sprites(x).Active = 1 THEN

            IF Sprites(x).SpriteName = "SLase" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    Player1.Locked = 1
                    Sprites(x).Frame = 1
                    IF Slasedisable = 1 THEN Sprites(x).Active = 0
                    Slasedisable = 1
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(7)
                END IF

                IF Sprites(x).Frame = 1 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(17), SpriteScreen&
                IF Sprites(x).Frame = 2 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(16), SpriteScreen&
                IF Sprites(x).Frame = 3 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(15), SpriteScreen&
                IF Sprites(x).Frame = 4 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(14), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(13), SpriteScreen&
                ELSEIF Sprites(x).Frame = 5 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(12), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(11), SpriteScreen&
                ELSEIF Sprites(x).Frame = 6 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(12), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(11), SpriteScreen&
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(8)
                    FOR z = 21 TO TotalSprites
                        IF Sprites(z).Active = 1 THEN
                            IF Sprites(z).PosY > Sprites(x).PosY - Sprites(x).Size AND Sprites(z).PosY < Sprites(x).PosY + Sprites(x).Size AND Sprites(z).PosX > Player1.PosX THEN Sprites(z).Health = Sprites(z).Health - 50
                        END IF
                    NEXT z
                    Sprites(x).Frame = 7
                ELSEIF Sprites(x).Frame = 7 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(10), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(9), SpriteScreen&
                ELSEIF Sprites(x).Frame = 8 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(8), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(7), SpriteScreen&
                ELSEIF Sprites(x).Frame = 9 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(6), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(5), SpriteScreen&
                ELSEIF Sprites(x).Frame = 10 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(4), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(3), SpriteScreen&
                ELSEIF Sprites(x).Frame = 11 THEN
                    _PUTIMAGE (Sprites(x).PosX + 10 - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Settings.RezX, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(2), SpriteScreen&
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(1), SpriteScreen&
                ELSEIF Sprites(x).Frame = 12 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(15), SpriteScreen&
                ELSEIF Sprites(x).Frame = 13 THEN _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(16), SpriteScreen&
                ELSEIF Sprites(x).Frame = 14 THEN
                    _PUTIMAGE (Sprites(x).PosX - Sprites(x).Size, Sprites(x).PosY - Sprites(x).Size)-(Sprites(x).PosX + Sprites(x).Size, Sprites(x).PosY + Sprites(x).Size), Laser2Sprite(17), SpriteScreen&
                    Sprites(x).Active = 0
                    Player1.Locked = 0
                    DisableLaserInput = 0
                    Slasedisable = 0
                END IF
                IF Sprites(x).Counter = Sprites(x).Delay THEN
                    Sprites(x).Counter = 0
                    Sprites(x).Frame = Sprites(x).Frame + 1
                ELSE
                    Sprites(x).Counter = Sprites(x).Counter + 1
                END IF
            END IF

            '---------------------------------------------------------------------------------------------------------

            IF Sprites(x).SpriteName = "Laser" AND Sprites(x).Active = 1 THEN
                IF Sprites(x).Frame = 0 THEN
                    Sprites(x).Frame = 1
                    IF Sprites(x).SoundDisabled = 0 THEN _SNDPLAY SFX(3)
                END IF

                IF Sprites(x).PosX > Settings.RezX - Sprites(x).MoveX + 41 THEN
                    Sprites(x).Active = 0
                ELSE
                    Sprites(x).PosX = Sprites(x).PosX + Sprites(x).MoveX
                END IF

                IF Sprites(x).Active = 1 THEN
                    _PUTIMAGE (Sprites(x).PosX, Sprites(x).PosY), Laser1Sprite, SpriteScreen&
                    _DEST CollisionData&
                    LINE (Sprites(x).PosX + 40, Sprites(x).PosY + 12)-(Sprites(x).PosX + 40 + Sprites(x).MoveX, Sprites(x).PosY + 12), _RGB(255, 0, 0)
                    _DEST SpriteScreen&

                    _SOURCE CollisionData&
                    FOR z = Sprites(x).PosX + 40 TO Sprites(x).PosX + Sprites(x).MoveX + 40
                        IF _BLUE(POINT(z, Sprites(x).PosY + 11)) <> 0 AND z < Settings.RezX - 1 AND _BLUE(POINT(z, Sprites(x).PosY + 11)) < 254 THEN
                            Collision = _BLUE(POINT(z, Sprites(x).PosY + 11))
                            IF Sprites(Collision).SpriteName <> "Heal1" AND Sprites(Collision).SpriteName <> "Heal5" AND Sprites(Collision).SpriteName <> "Speed" AND Sprites(Collision).SpriteName <> "Slasp" THEN
                                IF Sprites(Collision).SpriteName <> "Ball1" THEN Sprites(x).Active = 0
                                IF Sprites(Collision).Health >= 1 AND Collision <> 0 THEN Sprites(Collision).Health = Sprites(Collision).Health - 1
                                IF Sprites(Collision).Health > 0 THEN CALL SetupSprite(z, Sprites(x).PosY + 11, 0, 0, "Expl1", 15, 0, 0, 2, 0, 0, 1, 0)
                                EXIT FOR
                            END IF
                        END IF
                    NEXT z
                    _SOURCE Display&
                END IF
            END IF
        END IF

    NEXT x

    IF Player1.Stageover = 0 AND Player1.Health > 0 THEN
        _SOURCE CollisionData&
        CheckCollision (_BLUE(POINT(Player1.PosX + 31, Player1.PosY - 3)))
        CheckCollision (_BLUE(POINT(Player1.PosX + 63, Player1.PosY + 7)))
        CheckCollision (_BLUE(POINT(Player1.PosX + 31, Player1.PosY + 18)))
        _SOURCE Display&
    END IF
END SUB


SUB LoadSprites
    AsteroidSprite(1) = _LOADIMAGE("Images\Asteroid1a.png")
    AsteroidSprite(2) = _LOADIMAGE("Images\Asteroid1b.png")
    AsteroidSprite(3) = _LOADIMAGE("Images\Asteroid1c.png")

    Ball1Sprites(1) = _LOADIMAGE("Images\Ball1a.png")
    Ball1Sprites(2) = _LOADIMAGE("Images\Ball1b.png")
    Ball1Sprites(3) = _LOADIMAGE("Images\Ball1c.png")
    Ball1Sprites(4) = _LOADIMAGE("Images\Ball1d.png")

    Boss1Sprite = _LOADIMAGE("Images\Boss1.png")

    Boss2Sprites(1) = _LOADIMAGE("Images\Boss2.png")
    Boss2Sprites(2) = _LOADIMAGE("Images\Boss2a.png")
    Boss2Sprites(3) = _LOADIMAGE("Images\Boss2b.png")

    Boss3Sprites(1) = _LOADIMAGE("Images\Boss3m.png")
    Boss3Sprites(2) = _LOADIMAGE("Images\Boss3t.png")
    Boss3Sprites(3) = _LOADIMAGE("Images\Boss3b.png")
    Boss3Sprites(4) = _LOADIMAGE("Images\Boss3f.png")

    Laser1Sprite = _LOADIMAGE("Images\Laser.png")

    Health1Sprites(1) = _LOADIMAGE("Images\Health1a.png")
    Health1Sprites(2) = _LOADIMAGE("Images\Health1b.png")
    Health1Sprites(3) = _LOADIMAGE("Images\Health1c.png")
    Health1Sprites(4) = _LOADIMAGE("Images\Health1d.png")

    Health5Sprites(1) = _LOADIMAGE("Images\Health5a.png")
    Health5Sprites(2) = _LOADIMAGE("Images\Health5b.png")
    Health5Sprites(3) = _LOADIMAGE("Images\Health5c.png")
    Health5Sprites(4) = _LOADIMAGE("Images\Health5d.png")

    SpeedSprites(1) = _LOADIMAGE("Images\Speeda.png")
    SpeedSprites(2) = _LOADIMAGE("Images\Speedb.png")
    SpeedSprites(3) = _LOADIMAGE("Images\Speedc.png")
    SpeedSprites(4) = _LOADIMAGE("Images\Speedd.png")

    SlaserSprites(1) = _LOADIMAGE("Images\SLasera.png")
    SlaserSprites(2) = _LOADIMAGE("Images\SLaserb.png")
    SlaserSprites(3) = _LOADIMAGE("Images\SLaserc.png")
    SlaserSprites(4) = _LOADIMAGE("Images\SLaserd.png")

    Laser2Sprite(1) = _LOADIMAGE("Images\Laser2a.png")
    Laser2Sprite(2) = _LOADIMAGE("Images\Laser2ae.png")
    Laser2Sprite(3) = _LOADIMAGE("Images\Laser2b.png")
    Laser2Sprite(4) = _LOADIMAGE("Images\Laser2be.png")
    Laser2Sprite(5) = _LOADIMAGE("Images\Laser2c.png")
    Laser2Sprite(6) = _LOADIMAGE("Images\Laser2ce.png")
    Laser2Sprite(7) = _LOADIMAGE("Images\Laser2d.png")
    Laser2Sprite(8) = _LOADIMAGE("Images\Laser2de.png")
    Laser2Sprite(9) = _LOADIMAGE("Images\Laser2e.png")
    Laser2Sprite(10) = _LOADIMAGE("Images\Laser2ee.png")
    Laser2Sprite(11) = _LOADIMAGE("Images\Laser2f.png")
    Laser2Sprite(12) = _LOADIMAGE("Images\Laser2fe.png")
    Laser2Sprite(13) = _LOADIMAGE("Images\Laser2g.png")
    Laser2Sprite(14) = _LOADIMAGE("Images\Laser2ge.png")
    Laser2Sprite(15) = _LOADIMAGE("Images\Laser2h.png")
    Laser2Sprite(16) = _LOADIMAGE("Images\Laser2i.png")
    Laser2Sprite(17) = _LOADIMAGE("Images\Laser2j.png")

    Laser3Sprite(1) = _LOADIMAGE("Images\Laser3g.png")
    Laser3Sprite(2) = _LOADIMAGE("Images\Laser3f.png")
    Laser3Sprite(3) = _LOADIMAGE("Images\Laser3e.png")
    Laser3Sprite(4) = _LOADIMAGE("Images\Laser3d.png")
    Laser3Sprite(5) = _LOADIMAGE("Images\Laser3c.png")
    Laser3Sprite(6) = _LOADIMAGE("Images\Laser3b.png")
    Laser3Sprite(7) = _LOADIMAGE("Images\Laser3a.png")

    Laser4Sprite = _LOADIMAGE("Images\Laser4.png")

    Lightning1Sprites(1) = _LOADIMAGE("Images\Lightning1a.png")
    Lightning1Sprites(2) = _LOADIMAGE("Images\Lightning1b.png")
    Lightning1Sprites(3) = _LOADIMAGE("Images\Lightning1c.png")
    Lightning1Sprites(4) = _LOADIMAGE("Images\Lightning1d.png")
    Lightning1Sprites(5) = _LOADIMAGE("Images\Lightning1e.png")
    Lightning1Sprites(6) = _LOADIMAGE("Images\Lightning1f.png")
    Lightning1Sprites(7) = _LOADIMAGE("Images\Lightning1g.png")
    Lightning1Sprites(8) = _LOADIMAGE("Images\Lightning1h.png")

    EnemySprites(1) = _LOADIMAGE("Images\Ship2.png")
    EnemySprites(2) = _LOADIMAGE("Images\Ship3.png")
    EnemySprites(3) = _LOADIMAGE("Images\Ship4.png")
    EnemySprites(4) = _LOADIMAGE("Images\Ship5.png")
    EnemySprites(5) = _LOADIMAGE("Images\Ship6.png")
    EnemySprites(6) = _LOADIMAGE("Images\Ship7.png")
    EnemySprites(7) = _LOADIMAGE("Images\Ship8.png")
    EnemySprites(8) = _LOADIMAGE("Images\Ship9.png")
    FOR x = 1 TO 8
        _CLEARCOLOR _RGB(0, 0, 0), EnemySprites(x)
    NEXT x

    Explosion1Sprites(1) = _LOADIMAGE("Images\Explosion1a.png")
    Explosion1Sprites(2) = _LOADIMAGE("Images\Explosion1b.png")
    Explosion1Sprites(3) = _LOADIMAGE("Images\Explosion1c.png")
    Explosion1Sprites(4) = _LOADIMAGE("Images\Explosion1d.png")
    Explosion1Sprites(5) = _LOADIMAGE("Images\Explosion1e.png")
    Explosion1Sprites(6) = _LOADIMAGE("Images\Explosion1f.png")
    Explosion1Sprites(7) = _LOADIMAGE("Images\Explosion1g.png")
    Explosion1Sprites(8) = _LOADIMAGE("Images\Explosion1h.png")
    Explosion1Sprites(9) = _LOADIMAGE("Images\Explosion1i.png")
    Explosion1Sprites(10) = _LOADIMAGE("Images\Explosion1j.png")
    Explosion1Sprites(11) = _LOADIMAGE("Images\Explosion1k.png")
    Explosion1Sprites(12) = _LOADIMAGE("Images\Explosion1l.png")
    Explosion1Sprites(13) = _LOADIMAGE("Images\Explosion1m.png")
    Explosion1Sprites(14) = _LOADIMAGE("Images\Explosion1n.png")

    Explosion2Sprites(1) = _LOADIMAGE("Images\Explosion2a.png")
    Explosion2Sprites(2) = _LOADIMAGE("Images\Explosion2b.png")
    Explosion2Sprites(3) = _LOADIMAGE("Images\Explosion2c.png")
    Explosion2Sprites(4) = _LOADIMAGE("Images\Explosion2d.png")
    Explosion2Sprites(5) = _LOADIMAGE("Images\Explosion2e.png")
    Explosion2Sprites(6) = _LOADIMAGE("Images\Explosion2f.png")

    TeleportSprites(1) = _LOADIMAGE("Images\Teleport1a.png")
    TeleportSprites(2) = _LOADIMAGE("Images\Teleport1b.png")
    TeleportSprites(3) = _LOADIMAGE("Images\Teleport1c.png")
    TeleportSprites(4) = _LOADIMAGE("Images\Teleport1d.png")
    TeleportSprites(5) = _LOADIMAGE("Images\Teleport1e.png")
    TeleportSprites(6) = _LOADIMAGE("Images\Teleport1f.png")
    TeleportSprites(7) = _LOADIMAGE("Images\Teleport1g.png")
    TeleportSprites(8) = _LOADIMAGE("Images\Teleport1h.png")
    TeleportSprites(9) = _LOADIMAGE("Images\Teleport1i.png")
    TeleportSprites(10) = _LOADIMAGE("Images\Teleport1j.png")

    ShipSprites(1) = _LOADIMAGE("Images\Ship1.png")
    ShipSprites(2) = _LOADIMAGE("Images\Ship1u.png")
    ShipSprites(3) = _LOADIMAGE("Images\Ship1d.png")
    _CLEARCOLOR _RGB(255, 255, 255), ShipSprites(1)
    _CLEARCOLOR _RGB(255, 255, 255), ShipSprites(2)
    _CLEARCOLOR _RGB(255, 255, 255), ShipSprites(3)
END SUB

'************************************************
'
'************************************************
SUB SetupSprite (PosX, PosY, MoveX, MoveY, SpriteType$, Size, Growth, DisableSound, AnimType, Loops, Priority, Delay, Health)
    IF Settings.DisableSpawning = 0 OR LEFT$(SpriteType$, 4) = "Expl" THEN
        IF Priority = 0 THEN
            SpriteInit = EmptySprite
        ELSEIF Priority = 1 THEN
            SpriteInit = EmptyLaserSprite
        ELSE
            SpriteInit = Priority
        END IF

        IF SpriteType$ = "Aste1" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).Growth = Growth
            Sprites(SpriteInit).AnimationType = AnimType
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).AnimationLoops = Loops
            Sprites(SpriteInit).AnimationLooped = 0
            Sprites(SpriteInit).ColColorR = 255
            Sprites(SpriteInit).ColColorG = 255
            Sprites(SpriteInit).ColColorB = SpriteInit
            Sprites(SpriteInit).Health = Health
        END IF

        IF SpriteType$ = "Heal1" OR SpriteType$ = "Heal5" OR SpriteType$ = "Speed" OR SpriteType$ = "SLasp" THEN
            Sprites(SpriteInit).Frame = 1
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).ColColorR = 255
            Sprites(SpriteInit).ColColorG = 255
            Sprites(SpriteInit).ColColorB = SpriteInit
        END IF

        IF SpriteType$ = "Ball1" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).ColColorR = 255
            Sprites(SpriteInit).ColColorG = 255
            Sprites(SpriteInit).ColColorB = SpriteInit
            Sprites(SpriteInit).Health = Health
        END IF

        IF LEFT$(SpriteType$, 4) = "Boss" OR SpriteType$ = "Bos2a" OR SpriteType$ = "Bos2b" OR SpriteType$ = "Bos3t" OR SpriteType$ = "Bos3b" OR SpriteType$ = "Bos3f" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).Growth = Growth
            Sprites(SpriteInit).AnimationType = AnimType
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).AnimationLoops = Loops
            Sprites(SpriteInit).AnimationLooped = 0
            Sprites(SpriteInit).ColColorR = 1
            Sprites(SpriteInit).ColColorG = 1
            Sprites(SpriteInit).ColColorB = SpriteInit
            Sprites(SpriteInit).Health = Health
            Sprites(SpriteInit).MovementSwitch = 1
        END IF

        IF LEFT$(SpriteType$, 4) = "Ship" THEN
            Sprites(SpriteInit).Frame = 1
            Sprites(SpriteInit).AnimationLoops = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).ColColorR = 50
            Sprites(SpriteInit).ColColorG = 50
            Sprites(SpriteInit).ColColorB = SpriteInit
            Sprites(SpriteInit).Health = Health
            Sprites(SpriteInit).MovementSwitch = 1
        END IF

        IF LEFT$(SpriteType$, 4) = "Expl" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).Growth = Growth
            Sprites(SpriteInit).AnimationType = AnimType
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).AnimationLoops = Loops
            Sprites(SpriteInit).AnimationLooped = 0
        END IF

        IF SpriteType$ = "Laser" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = "Laser"
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
        END IF

        IF SpriteType$ = "SLase" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
            Sprites(SpriteInit).MovementSwitch = 0
        END IF

        IF SpriteType$ = "Lase3" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
        END IF

        IF SpriteType$ = "Lase4" THEN
            Sprites(SpriteInit).Frame = 0
            Sprites(SpriteInit).Delay = Delay
            Sprites(SpriteInit).Counter = 0
            Sprites(SpriteInit).SpriteName = SpriteType$
            Sprites(SpriteInit).Size = Size
            Sprites(SpriteInit).PosX = PosX
            Sprites(SpriteInit).PosY = PosY
            Sprites(SpriteInit).MoveX = MoveX
            Sprites(SpriteInit).MoveY = MoveY
            Sprites(SpriteInit).SoundDisabled = DisableSound
            Sprites(SpriteInit).Active = 1
        END IF

    END IF
END SUB

SUB KillAllSprites
    FOR x = 1 to TotalSprites
        Sprites(x).Active = 0
    NEXT x
END SUB

SUB FireLazar
    CALL SetupSprite(Player1.PosX + 15, Player1.PosY + 3, 20, 0, "Laser", 0, 0, 0, 1, 0, 1, 30, 0)
END SUB

SUB MenuFire
    CALL SetupSprite(10, Settings.RezY - 37, 20, 0, "Laser", 0, 0, 1, 1, 0, 1, 30, 0)
END SUB

