'$INCLUDE:'Main.bh'
ON ERROR GOTO ErrorHandle

InitEngine
PRINT "Stereospace "; Settings.Version
PRINT
PRINT "Init Complete.."
PRINT "Loading Sprites.."
LoadSprites
PRINT "Loading Sounds.."
LoadSounds
PRINT "Loading Music.."
LoadMusic
PRINT "Done!"

IF Settings.DesignerMode = 0 THEN MainMenu


KillAllSprites
ResetPlayer
LoadStage

TIMER(ReadFileTimer) ON
Settings.DisableCollisions = 0
MainLoop

ErrorHandle:
ErrorHandler


SUB MainLoop
    DO
        _LIMIT 30
        IF _KEYDOWN(17408) THEN ERROR 97

        IF Settings.DesignerMode = 1 THEN
            Player1.NoDraw = 1
            Player1.Locked = 1
            Player1.PosX = -150
            Player1.PosY = Settings.RezY / 2
            IF _KEYDOWN(27) THEN SYSTEM
        END IF
        Player1.Frame = 1
        IF Player1.Stageover = 1 THEN
            TIMER(FireLazarTimer) OFF
            TIMER(ReadFileTimer) OFF
            Player1.Locked = 1
            Player1.PosX = Player1.PosX + 50
            IF Player1.PosX > Settings.RezX + 50 THEN Player1.Stageover = 2
        ELSEIF Player1.Stageover = 2 THEN
            FadeOut
            KillAllSprites
            Player1.Stageover = 0
            Player1.PosX = 25
            Player1.PosY = INT(Settings.RezY / 2)
            Player1.SpawnData = ""
            Player1.Locked = 0
            Player1.Stage = Player1.Stage + 1
            Settings.StageSongLoaded = 0
            CALL JukeBox2("Level", "Stop")
            LoadStage
        END IF

        DO WHILE _MOUSEINPUT
            IF Player1.Locked = 0 THEN
                IF _MOUSEX > Player1.PosX THEN
                    Player1.PosX = Player1.PosX + Player1.Speed
                    IF Player1.PosX > Settings.RezX THEN Player1.PosX = Settings.RezX
                END IF

                IF _MOUSEX < Player1.PosX THEN
                    Player1.PosX = Player1.PosX - Player1.Speed
                    IF Player1.PosX < 5 THEN Player1.PosX = 5
                END IF

                IF _MOUSEY > Player1.PosY THEN
                    Player1.Frame = 3
                    Player1.PosY = Player1.PosY + Player1.Speed
                    IF Player1.PosY > Settings.RezY - 20 THEN Player1.PosY = Settings.RezY - 20
                END IF

                IF _MOUSEY < Player1.PosY THEN
                    Player1.Frame = 2
                    Player1.PosY = Player1.PosY - Player1.Speed
                    IF Player1.PosY < 0 THEN Player1.PosY = 0
                END IF

                IF _MOUSEBUTTON(1) = -1 THEN TIMER(FireLazarTimer) ON
                IF _MOUSEBUTTON(1) = 0 THEN TIMER(FireLazarTimer) OFF

                IF _MOUSEBUTTON(2) AND DisableLaserInput = 0 AND Player1.SLaser > 0 THEN
                    DisableLaserInput = 1
                    Player1.Locked = 1
                    Player1.SLaser = Player1.SLaser - 1
                    CALL SetupSprite(Player1.PosX + 150, Player1.PosY + 5, 0, 0, "SLase", 80, 0, 0, 1, 0, 1, 1, 0)
                END IF
            END IF
        LOOP

        DrawOverlay
        DrawSprites
        AnimateStars
        AssembleDisplay

    LOOP UNTIL _KEYDOWN(113) OR _KEYDOWN(81)
    GameOver
END SUB




'$INCLUDE:'Graphics.bi'
'$INCLUDE:'Error.bi'
'$INCLUDE:'Sprite.bi'
'$INCLUDE:'Audio.bi'
'$INCLUDE:'Misc.bi'
