SUB LoadSounds
    SFX(1) = _SNDOPEN("Sounds\SmallExplosion.wav")
    SFX(2) = _SNDOPEN("Sounds\BigExplosion.wav")
    SFX(3) = _SNDOPEN("Sounds\Laser.wav")
    SFX(4) = _SNDOPEN("Sounds\Ball1.wav")
    SFX(5) = _SNDOPEN("Sounds\ShipHit.wav")
    SFX(6) = _SNDOPEN("Sounds\PlayerDeath.wav")
    SFX(7) = _SNDOPEN("Sounds\Charge.wav")
    SFX(8) = _SNDOPEN("Sounds\Blast.wav")
    SFX(9) = _SNDOPEN("Sounds\Laser3Charge.wav")
    SFX(10) = _SNDOPEN("Sounds\Laser3.wav")
    SFX(11) = _SNDOPEN("Sounds\Teleport.wav")
    SFX(12) = _SNDOPEN("Sounds\Laser4.wav")
    SFX(13) = _SNDOPEN("Sounds\Boss3sep.wav")
    SFX(14) = _SNDOPEN("Sounds\Heal1.wav")
    SFX(15) = _SNDOPEN("Sounds\Heal5.wav")
    SFX(16) = _SNDOPEN("Sounds\Speed.wav")
    SFX(17) = _SNDOPEN("Sounds\SLaser.wav")
    SFX(18) = _SNDOPEN("Sounds\Start.wav")
    SFX(19) = _SNDOPEN("Sounds\Gameover.wav")
END SUB

SUB LoadMusic
    IntroSong = _SNDOPEN("Music\Intro.mp3")
    BossSong = _SNDOPEN("Music\Boss.mp3")
    _SNDVOL BossSong, 0.5
    _SNDVOL LevelSong, 0.5
END SUB

SUB JukeBox2 (Song$, Button$)
    IF Song$ = "Intro" THEN
        IF Button$ = "Loop" THEN
            _SNDLOOP IntroSong
        ELSEIF Button$ = "Stop" THEN
            _SNDSTOP IntroSong
        END IF
    END IF

    IF Song$ = "Level" THEN
        IF Button$ = "Play" THEN _SNDPLAY LevelSong
        IF Button$ = "Stop" THEN _SNDSTOP LevelSong
    END IF

    IF Button$ = "Swap" THEN
        IF Song$ = "Boss" THEN
            _SNDPAUSE LevelSong
            _SNDPLAY BossSong
        ELSE
            _SNDSTOP BossSong
            _SNDPLAY LevelSong
        END IF
    END IF

    IF Song$ = "Boss" AND Button$ = "Stop" THEN _SNDSTOP BossSong

    IF Button$ = "Insert" THEN
        LevelSong = _SNDOPEN(Song$)
        _SNDVOL LevelSong, 0.5
    END IF
END SUB
